The effect of adding randomly weighted edges
Abstract
We consider the following question. We have a dense regular graph with degree , where is a constant. We add random edges. The edges of the augmented graph are given independent edge weights . We estimate the minimum weight of some specified combinatorial structures. We show that in certain cases, we can obtain the same estimate as is known for the complete graph, but scaled by a factor . We consider spanning trees, shortest paths and perfect matchings in (pseudo-random) bipartite graphs.
1 Introduction
It is often the case that adding some randomness to a combinatorial structure can lead to significant positive change. Perhaps the most important example of this and the inspiration for a lot of what has followed, is the seminal result of Spielman and Teng [34] on the performance of the simplex algorithm, see also Vershynin [37] and Dadush and Huiberts [13].
The paper [34] inspired the following model of Bohman, Frieze and Martin [10]. They consider adding random edges to an arbitrary member of . Here is a positive constant and is the set of graphs with vertex set and minimum degree at least . They show that adding random edges to is enough to create a Hamilton cycle w.h.p. This is in contrast to the approximately edges needed if we rely only on the random edges. Research on this model and its variations has been quite substantial, see for example [11], [29], [35], [25], [26], [12], [5], [28], [9], [21], [14], [33], [16], [31].
Anastos and Frieze [4] introduced a variation on this theme by adding color to the edges. They consider rainbow Hamiltonicity and rainbow connection in the context of a randomly colored dense graph with the addition of randomly colored edges. Aigner-Horev and Hefetz [1] strengthened the Hamiltonicity result of [4].
In this paper we introduce another variation. We start with a dense graph in which each edge has a random weight and add randomly weighted random edges. We study the effect on the minimum value of various combinatorial structures. We will for simplicity restrict our attention to what we will call , the graphs in that are regular.
1.1 Spanning Trees
We start with spanning trees. Suppose that and each edge of is given an independent random weight chosen uniformly from . Let denote the expected minimum weight of a spanning tree of , assuming it is connected. Beveridge, Frieze and McDiarmid [6] and Frieze, Ruszinko and Thoma [20] show that assuming certain connectivity conditions on ,
(1) |
where for a positive integer we have .
Here if as and if as and if .
Now let be obtained from by adding random edges to . Each added random edge also has an independent uniform weight. Also, let be obtained from by independently adding randomly weighted copies of edges not in , with probability . We let denote the added edges. Our first theorem is a simple extension of (1).
Theorem 1.
Suppose that and and the edges of have independent weights chosen uniformly from . Then w.h.p.
(2) |
In addition, if then (2) holds without the use of random edges.
This theorem is very easy to prove. One simply verifies that certain conditions in [6] hold w.h.p. On the other hand it sets the stage for what we are trying to prove in other scenarios. The upper bound on is not essential, we could most likely replace it by , but this would require us to re-do the calculations in [6].
Without the addition of random edges, all that can be claimed (assuming is connected) is that
(3) |
See [20].
Conjecture: The +1 in (3) can be replaced by +1/2 (which is best possible).
The example giving 1/2 is a collection of copies of where there is a perfect matching on the vertices of degree added so that the copies of are connected in a cycle by bridges.
1.2 Shortest paths
We turn our attention next to shortest paths. Janson [23] considered the following scenario: the edges of are given independent exponential mean one random lengths, denoted by . Let denote the shortest distance between vertex and vertex . He shows that w.h.p.
Bhamidi and van der Hofstad [7] proved an equivalent expression for for a much wider class of distribution. They actually determined an asymptotic limiting distribution. (See also Bhamidi, van der Hofstad and Hooghiemstra [8].) We prove the following:
Theorem 2.
Suppose that and that and the edges of are given independent exponential mean one random lengths. Let denote the shortest distance between vertex and vertex . Then w.h.p.
In addition, if then (2) holds without the use of random edges.
1.3 Bipartite matchings
We turn our attention next to bipartite matchings. For background consider the following well-studied problem: each edge of the complete bipartite graph is given an independent edge weight . Let denote the minimum weight of a perfect matching in this context. Walkup [38] considered the case where is uniform and proved that . Later Karp [24] proved that . Aldous [2, 3] proved that if the are independent exponential mean one random variables then . Parisi [32] conjectured that in fact . This was proved independently by Linusson and WΓ€stlund [27] and by Nair, Prabhakar and Sharma [30]. A short elegant proof was given by WΓ€stlund [40, 41].
We now consider . is an regular bipartite graph with vertex set . Unfortunately, our proof only works if is pseudo-random, as defined by Thomason [36]. By this we mean that for some we have
(4) |
Here, as usual, .
Theorem 3.
Let be a pseudo-random regular bipartite graph with vertex set . Suppose that . Let denote the minimum weight of a perfect matching when the weights of the edges of are independent exponential mean one random variables. (To be clear, the added random edges have endpoints in the different vertex classes and , so that is bipartite.) Then
(5) |
Conjecture: equation (5) holds for , growing sufficiently quickly, but without the assumption of pseudo-randomness.
Frieze and Johansson [18] showed that if is the random bipartite graph where then
(6) |
That paper also conjectured that if is a sequence of -regular bipartite graphs with vertices that as . This conjecture is false. Instead we have:
Conjecture: if the connectivity of tends to infinity. Also, in general .
The 1/2 here is best possible in general. We take copies of where there is a perfect matching on the vertices of degree added so that the copies of are connected in a cycle by bridges.
In what follows we will sometimes treat large values as integers when strictly speaking we should round up or down. In all cases the choice of up or down has negligible effect on the proof.
2 Spanning Trees
Theorem 2 of Beveridge, Frieze and McDiarmid [6] yields the following. Suppose that
(7) |
Let denote the set of edges of with exactly one endpoint in . Then (2) holds if
(8) |
Now if we add random edges satisfying the conditions of the theorem then all degrees will be and this will satisfy (7).
So, to prove Theorem 1, all we need to do is to verify (8). Now let . The probability that contains a set failing to satisfy (8) can be bounded by
(9) |
where we have just looked at the edges to satisfy (8). The property described in (8) is monotone increasing and so the upper bound in (9) holds in as well, see for example Lemma 1.3 of [19].
3 Shortest Paths
We use the ideas of Janson [23]. Sometimes we make a small tweak and in one case we shorten his proof considerably. The case will be discussed at the end of this section. We note that the lower bounds hold a fortiori if we do not have random edges .
3.1
We set and and consider running Dijkstraβs shortest path algorithm [15]. At the end of Step we will have computed and where is the minimum length of a path from 1 to . Let there be edges from to . Arguing as in [23] we see that where is the minimum of independent exponential mean one random variables, independent of . We note that
(10) |
Suppose now that
It follows that w.h.p. . Now
and so
w.h.p. for . | (11) |
Conditioning on the set of added edges and taking expectations with respect to edge weights, we see that if then
(12) |
By the same token,
(13) |
3.1.1 Upper Bound
If then w.h.p. for . Now execute Dijkstraβs algorithm from vertex 2 and let correspond to . If then we already have . If are disjoint then we use the random edges or . Let . Then,
(14) |
So, in this case we see too that w.h.p.
3.1.2 Lower Bound
We now consider a lower bound for . Let . We observe that because w.h.p. all vertices have degree and because the edge joining to is uniform among edges, we see that . By the same token, . It follows that w.h.p.
3.2
3.2.1 Lower Bound
For this we run Dijkstraβs algorithm until all vertices have been included in the shortest path tree. We can therefore immediately see that if then
(15) |
The second sum in (15) is the contribution from adding the final vertices and uses w.h.p. for . Equation (13) allows us to claim the lower bound w.h.p.
3.2.2 Upper Bound
3.3
3.3.1 Lower Bound
Our proof here is somewhat shorter than that in [23], but it is based on the same idea. We begin with a lower bound. Let . Let . Then, given that all vertex degrees are asymptotically equal to , we have that for ,
(17) |
An application of the Chebyshev inequality shows that w.h.p. and we can assume the existence of . Now the expected number of paths from to of length at most can be bounded by
(18) |
Explanation for (18): The first factor is the expected number of pairs of vertices . The second factor is a bound on the number of choices for the neighbors of on the path. The third factor is a bound on the expected number of paths of length at most from to , . This factor comes from
Here is the number of internal vertices on the path. There will be choices for the sequence of vertices on the path. We then use the fact that the exponential mean one random variable stochastically dominates the uniform random variable . The final two factors are the probability that the sum of independent copies of sum to at most . Continuing we have
The final factor in (18) is a bound on the probability that . For this we use the fact that is distributed as where are independent exponential mean one. Now and taking justifies the final factor of (18).
3.3.2 Upper Bound
We now consider the upper bound. Let where is from Section 3.1 and . For we have that w.h.p. over our choice of , that
where the are as in (10).
Then for any and for we have
It follows, on taking that w.h.p.
Letting be the set corresponding to when we execute Dijkstraβs algorithm starting at , then we have that for where ,
(19) |
and this is enough to complete the proof of Theorem 2, except for when and we do not add random edges.
3.4
The edges are needed for (14), (16) and (19). In each case we are two sets of size say and we need to argue for a short edge between them. In our case we look for a short path of length two. So, let denote the number of triples where and and the lengths of edges are both at most . Let denote the set of such triples, so that . The lengths of candidate edges will not be conditioned by the history of the process. We use Jansonβs inequality [22].
Each pair have at least common neighbors. It follows that
We then estimate
where if or .
4 Bipartite matchings
We find, just as in [18], that the proofs in [40], [41] can be adapted to our current situation. Suppose that the vertices of are denoted and . We will need to assume that
We will use the notation for edges of , where and . We will let denote the weight of . Let and let denote the weight of the minimum weight matching of of into . ( is unique with probability one.) Suppose also that is defined by . Let .
We will prove that
(21) |
for .
Using this and a simple argument for we argue that
(22) |
4.1 Proof details
We add a special vertex to , with edges to all vertices of . Each edge adjacent to is assigned an weight independently, . Here is an exponential random variable of rate i.e. . We now consider to be the minimum weight matching of into . (As it becomes increasingly unlikely that any of the extra edges are actually used in the minimum weight matching.) We denote this matching by and we let denote the corresponding set of vertices of that are covered by .
Define as the normalized probability that participates in , i.e.
(23) |
Its importance lies in the following lemma:
Lemma 4.
(24) |
Proof.
Choose randomly from and let be the -vertices in the minimum weight matching of into . Let and let . Let be the weight of the edge , and let denote the indicator variable for the event that the minimum weight of an matching that contains this edge is smaller than the minimum weight of an matching that does not use . We can see that is the indicator variable for the event , where is the minimum weight of a matching from to . Indeed, if then . Conversely, if and no other edge from has weight smaller than , then , and when , the probability that there are two distinct edges from of weight smaller than is of order . Indeed, let denote the existence of two distinct edges from of weight smaller than and let denote the event that and both have weight smaller than .
Then,
(25) |
and since is finite and independent of , this is .
Note that and have the same distribution. They are both equal to the minimum weight of a matching of a random -set of into . As a consequence, . Since is distributed, as we have from (25) that
β
We now proceed to estimate . Fix and assume that . Suppose that is obtained from by finding an augmenting path from to of minimum additional weight. We condition on (i) , (ii) the lengths of all edges other than and (iii) . With this conditioning will be fixed and so will . We can now use the following fact: Let be independent exponential random variables of rates . Then the probability that is the smallest of them is . Furthermore, the probability stays the same if we condition on the value of . Thus
where is the number of neighbors of in .
Lemma 5.
(26) |
Proof.
(27) |
β
It is this point we need to assume that is pseudo-random. We have used this to control the values of the . We now state (part of) Theorem 2 of Thomason [36] in terms of our notation. Assume that is as in Theorem 3.
Theorem 6.
If and and , then
where is the number of edges with one end in and the other in .
4.1.1 Upper bound
We begin with an upper bound estimate for (27). This means finding lower bounds for the . Let
(28) |
We will establish bounds on as we proceed through the proof. We will then choose suitable values for these parameters.
We have the trivial bound which implies that
(29) |
Now suppose that and let
We claim that Theorem 6 implies that cannot occur for . Indeed, suppose that occurs. Then
(30) |
On the other hand, Theorem 6 implies that
(31) |
Plugging in the values from (28) into (30) and (31) we see that after subtracting the RHS of (30) is and the RHS of (31) is , a contradiction, assuming
(32) |
Let
(33) |
Let denote the number of times that vertex takes the role of . We will show that with probability that
(34) |
We will prove below that if then with probability
(35) |
Let be the indicator for the exceptions in (35).
Let be an equitable partition of into consecutive intervals of length . By equitable we mean that for all . Given that doesnβt occur and (35) we see that with probability we have
(36) |
Consequently, if and
(37) |
then with probability we have
(38) |
assuming that
(39) |
Explanation: The first term in (38) comes from (29). For a proof of the final estimate in (38) we refer the reader to Section A in an appendix. (The calculation is taken from [18].)
We show later that with probability we have
(40) |
To get an upper bound on we have to deal with the possibility of failure of (35). So what we do is to think of adding as the union of two copies of , a red copy and a blue copy. With just the red copy, we see that with probability we have and we use (6) for the blue copy. Thus,
4.1.2 Lower bound
Let and and and equitably partition into intervals of length and define as before. Fix and let . Next let denote the set of elements of that appear times as in and let . Let denote the subset of corresponding to . Partition into copies of in a natural way. Then it follows from Theorem 6 that if then for ,
Therefore,
It follows then that
(41) |
We have from (41) and the fact that the harmonic mean is at most the arithmetic mean that if
(42) |
then, assuming
(43) |
Therefore,
(44) |
Explanation: the term accounts for the third summation in the last term of the first line only going as far as instead of . The term , which is small due to (43), accounts for the summand in the last term of the first line being missing, due to the same thing.
4.1.3 No long edges
The aim of this section is to show that w.h.p. no edges of weight more than (where ) are used in the construction of . Here is a sufficiently large constant. For a set we let
And for let
Let
Lemma 7.
W.h.p. we have
(45) | ||||
(46) | ||||
(47) | ||||
(48) | ||||
(49) |
Proof.
We first observe that is distributed as and and so the Chernoff bounds imply that
We next observe that for a fixed we have
(Here is used to indicate the distribution of .)
If then . So,
If then . So,
If then . So,
If , let . Then, and so
β
Lemma 8.
W.h.p., no edge of length at least appears in any
Proof.
We first consider . If and then (45) implies that there are at least choices of such that we can reduce the matching cost by replacing by .
We now consider . Choose and let and let an alternating path be acceptable if (i) , , (ii) and (iii) .
Now consider the sequence of sets defined as follows:
Case (a): . In this case we define , where . By construction then, every vertex in is the endpoint of some acceptable alternating path.
Case (b): . In this case there exists which is the endpoint of some acceptable augmenting path.
It follows from (46) applied to that w.h.p. there exists such that and so Case (b) holds. This implies that if then for all . For if then there are at least choices of such that we can reduce the matching cost by deleting and changing via an acceptable augmenting path from to . The extra cost of the edges added in this path is .
Now consider . We know that w.h.p. there is such that and that by (47) we have that w.h.p. and we are in Case (b) and there is a low cost augmenting path for every , as in the previous case. When we use the same argument and find by (48) we have w.h.p. and there is a low cost augmenting path. Similarly for , using (49).
Finally note that the number of edges in the augmenting paths we find is always at most . β
We finally consider (35). Consider how a vertex loses neighbors in . It can lose up to for the times when . Otherwise, it loses a neighbor when chooses a common neighbor with . The important point here is that this choice depends on the structure of , but not on the weights of edges incident with . It follows that the cheapest neighbors at any time are randomly distributed among the current set of available neighbors. To get to the point where and , we must have at least one of the original cheapest neighbors occuring in a random subset of a set of size . This has probability and (35) follows from the Markov inequality.
5 Final remarks
We have shown that adding sufficiently many random edges is enough to βsmooth outβ the optimal value in certain optimization problems. There are several questions that remain. The first is to remove the pseudo-random requirement from Theorem 3. The problem is to control the sizes of the . Another possibility is to consider matchings and 2-factors in arbitrary regular graphs, not just bipartite ones. Then one can consider the Travelling Salesperson problem. We could also consider relaxing to be and we can consider more general distributions than .
References
- [1] E. Aigner-Horev and D. Hefetz, Rainbow Hamilton cycles in randomly coloured randomly perturbed dense graphs.
- [2] D. Aldous, Asymptotics in the random assignment problem, Probability Theory and Related Fields 93 (1992) 507-534.
- [3] D. Aldous, The limit in the random assignment problem, Random Structures and Algorithms 4 (2001) 381-418.
- [4] M. Anastos and A.M. Frieze, How many randomly colored edges make a randomly colored dense graph rainbow Hamiltonian or rainbow connected?, Journal of Graph Theory 92 (2019) 405-414.
- [5] J. Balogh, A. Treglown and A. Wagner, Tilings in randomly perturbed dense graphs, Combinatorics, Probability and Computing 28 (2019) 159-176.
- [6] A. Beveridge, A.M. Frieze and C. McDiarmid, Random minimum length spanning trees in regular graphs, Combinatorica 18 (1998) 311-333.
- [7] S. Bhamidi and R. van der Hofstadt, Weak disorder in the stochastic mean field model of distance, Annals of Applied Probability 22 (2012) 29-69.
- [8] S. Bhamidi, R. van der Hofstadt and G. Hooghiemstra, First passage percolation on random graphs with finite mean degrees, Annals of Probability 20 (2010) 1907-1965.
- [9] W. Bedenknecht, J. Han and Y. Kohayakawa, Powers of tight Hamilton cycles in randomly perturbed hypergraphs, Random Structures and Algorithms 55 (2019) 795-807.
- [10] T. Bohman, A.M. Frieze and R. Martin, How many random edges make a dense graph Hamiltonian?, Random Structures and Algorithms 22 (2003) 33-42.
- [11] T. Bohman, A.M. Frieze, M. Krivelevich and R. Martin, Adding random edges to dense graphs, Random Structures and Algorithms 24 (2004) 105-117.
- [12] J. BΓΆttcher, R. Montgomery, O. Parczyk and Y. Person, Embedding spanning bounded degree graphs in randomly perturbed graphs, Electronic Notes in Discrete Mathematics 61 (2017) 155-161.
- [13] D. Dadush and S. Huiberts, A friendly smoothed analysis of the simplex method, Proceedings of STOC 2018.
- [14] S. Das and A. Treglown, Ramsey properties of randomly perturbed graphs: cliques and cycles, to appear in Combinatorics, Probability and Computing.
- [15] E. Dijkstra, A note on two problems in connexion with graphs, Numerische Mathematik 1 (1959) 269-271.
- [16] A. Dudek, C. Reiher, A. RuciΕski and M. Schacht, Powers of Hamiltonian cycles in randomly augmented graphs, Random Structures and Algorithms 56 (2020) 122-141.
- [17] C.M. Fortuin, P.W. Kasteleyn and J. Ginibre, Correlation inequalities on some partially ordered sets, Communications in Mathematical Physics 22 (1971) 89-103,
- [18] A.M. Frieze and T. Johansson, Minimum-cost matching in a random graph with random costs, SIAM Journal on Discrete Mathematics 31 (2017) 489-510.
- [19] A.M. Frieze and M. KaroΕski, Introduction to Random Graphs, Cambridge University Press, 2015.
- [20] A.M. Frieze, M. Ruszinko and L. Thoma, A note on random minimum length spanning trees, Electronic Journal of Combinatorics 7 (2000).
- [21] J. Han and Y. Zhao, Hamiltonicity in randomly perturbed hypergraphs, Journal of Combinatorial Theory, Series B (2020) 14-31.
- [22] S. Janson, Poisson approximation for large deviations, Random Structures and Algorithms 1 (1990) 221-230.
- [23] S. Janson, One, two and three times for paths in a complete graph with random weights, Combinatorics, Probability and Computing 8 (1999) 347-361.
- [24] R.M. Karp, An upper bound on the expected cost of an optimal assignment, Discrete Algorithms and Complexity: Proceedings of the Japan-US Joint Seminar (D. Johnson et al., eds.), Academic Press, New York, 1987, 1-4.
- [25] M. Krivelevich, M. Kwan and B. Sudakov, Cycles and matchings in randomly perturbed digraphs and hypergraphs, Combinatorics, Probability and Computing 25 (2016) 909-927.
- [26] M. Krivelevich, M. Kwan and B. Sudakov, Bounded-degree spanning trees in randomly perturbed graphs,
- [27] S. Linusson and J. WΓ€stlund, A proof of Parisiβs conjecture on the random assignment problem, Probability Theory and Related Fields 128 (2004) 419-440.
- [28] A. McDowell and R. Mycroft, Hamilton -cycles in randomly-perturbed hypergraphs, The electronic journal of combinatorics 25 (2018).
- [29] M. Krivelevich, B. Sudakov and P. Tetali, On smoothed analysis in dense graphs and formulas, Random Structures and Algorithms 29 (2006) 180-193.
- [30] C. Nair, B. Prabhakar and M. Sharma, Proofs of the Parisi and Coppersmith-Sorkin random assignment conjectures, Random Structures and Algorithms 27 (2005) 413-444.
- [31] O. Parczyk, 2-universality in randomly perturbed graphs, European Journal of Combinatorics 87 (2020) 103-118.
- [32] G. Parisi, A conjecture on Random Bipartite Matching, Physics e-Print archive (1998).
- [33] E. Powierski, Ramsey properties of randomly perturbed dense graphs.
- [34] D. Spielman and S. Teng, Smoothed Analysis of the Simplex Algorithm, Journal of the ACM 51 (2004) 385-463.
- [35] B. Sudakov and J. Vondrak, How many random edges make a dense hypergraph non-2-colorable?,
- [36] A. Thomason, Dense expanders and pseudo-random bipartite graphs, Discrete Mathematics 75 (1989) 381-386.
- [37] R. Vershynin, Beyond Hirsch Conjecture: Walks on Random Polytopes and Smoothed Complexity of the Simplex Method, SIAM Journal on Computing 39 (2009) 646β678.
- [38] D.W. Walkup, On the expected value of a random asignment problem, SIAM Journal on Computing 8 (1979) 440-442.
- [39] J. WΓ€stlund, Random matching problems on the complete graph, Electronic Communications in Probability (2008) 258-265.
- [40] J. WΓ€stlund, A simple proof of the Parisi and Coppersmith-Sorkin formulas for the random assignment problem, LinkΓΆping Studies in Mathematics 6 (2005).
- [41] J. WΓ€stlund, An easy proof of the limit in the random assignment problem, Electronic Communications in Probability 14 (2009) 261-269.
- [42] R.M. Young, Eulerβs constant, Mathematical Gazette 75 (1991) 187-190.
Appendix A Proof of final estimate from (38)
We use the following expression from Young [42].
(52) |
(53) | ||||
We can replace the sum in (53) by an integral because the sequence of summands is unimodal and the terms are all .